﻿using UnityEngine;
using System.Collections;

public class Gui : MonoBehaviour {
	
	public Texture topBar;
	public Texture stageClear;
	public Texture stageFailed;
	public Texture gameOver;
	
	private Levels levelScript;
	
	// Use this for initialization
	void Start () {
		levelScript = GameObject.Find("Level").GetComponent("Levels") as Levels;
	}
	
	// Update is called once per frame
	void Update () {
		if (Registry.health <= 0 && !Registry.stageClear && !Registry.stageFailed && !Registry.gameOver) {
			Registry.lives -= 1;
			Registry.timerRunning = false;
			if (Registry.lives <= 0) {
				Registry.gameOver = true;
			} else {
				Registry.stageFailed = true;
			}
			
		}
		
		if (Input.GetKeyDown("space")) {
			if (Registry.stageClear) {
				nextLevel();
				Registry.stageClear = false;
			} else if (Registry.stageFailed) {
				restartLevel();
				Registry.stageFailed = false;
			} else if (Registry.gameOver) {
				Registry.gameOver = false;
				Application.LoadLevel("start");
			}
		}
		
		
		//TIMER
		if (Registry.timerRunning) {
			Registry.timer -= Time.deltaTime;
			if (Registry.timer <= 0) {
				Registry.timerRunning = false;
				Registry.lives -= 1;
				Registry.stageFailed = true;
			}
		}
		
	}
	
	void OnGUI () {
		GUI.DrawTexture(new Rect(0f,0f,960f,60f), topBar);
		GUI.Label(new Rect(10f,10f,200f,20f), "Time left: " + Registry.timer.ToString("F2") + " seconds");	
		GUI.Label(new Rect(200f,10f,200f,20f), "Score: " + Registry.score);	
		GUI.Label(new Rect(400f,10f,200f,20f), "Health: " + Registry.health);
		GUI.Label(new Rect(600f,10f,200f,20f), "Lives: " + Registry.lives);
		GUI.Label(new Rect(800f,10f,160f,20f), "Level: " + Registry.level);
		
		if (Registry.stageClear) {
			Registry.timerRunning = false;
			GUI.DrawTexture(new Rect(0f,0f,960f,600f), stageClear);
		}
		
		if (Registry.stageFailed) {
			Registry.timerRunning = false;
			GUI.DrawTexture(new Rect(0f,0f,960f,600f), stageFailed);	
		}
		
		if (Registry.gameOver) {
			GUI.DrawTexture(new Rect(0f,0f,960f,600f), gameOver);	
		}
	}
	
	
	void restartLevel() {
		Registry.health = 100;
		Registry.score -= 200;
		Registry.timer = 10;
		levelScript.loadLevel(Registry.level);
		
	}
	
	void nextLevel() {
		Registry.level += 1;
		Registry.health = 100;
		Registry.timer = 10;
		levelScript.loadLevel(Registry.level);
		
	}
}
