﻿using UnityEngine;
using System.Collections;

public class Levels : MonoBehaviour {
	
	public GameObject wallsPrefab;
	public GameObject coinsPrefab;
	public GameObject playerPrefab;
	public GameObject enemyPrefab;
	public GameObject exitPrefab;
	
	private int sizeX;
	private int sizeZ;

	private int playerX;
	private int playerZ;
	
	private int exitX;
	private int exitZ;
	private float exitRotation;
	
	private int[,] walls;
	private int[,] coins;
	private int [,] enemies;
	

	// Use this for initialization
	void Start () {
		loadLevel(1);
	}
	
	// Update is called once per frame
	void Update () {
	
	}
	
	
	public void loadLevel(int level) {
		
		GameObject curLevel = GameObject.Find("curLevel(Clone)");
		if (curLevel) {
			DestroyImmediate(curLevel.gameObject);	
		}
		
		switch (level) {
			case 1:
				playerX 		= Level1.playerX;
				playerZ 		= Level1.playerZ;
				exitX		 	= Level1.exitX;
				exitZ			= Level1.exitZ;
				exitRotation 	= Level1.exitRotation;
				walls 			= Level1.walls;
				coins 			= Level1.coins;
				enemies 		= Level1.enemies;
				
				sizeX = walls.GetLength(1);
				sizeZ = walls.GetLength(0);
			
				drawLevel();
				break;
			case 2:
				playerX 		= Level2.playerX;
				playerZ 		= Level2.playerZ;
				exitX		 	= Level2.exitX;
				exitZ			= Level2.exitZ;
				exitRotation 	= Level2.exitRotation;
				walls 			= Level2.walls;
				coins 			= Level2.coins;
				enemies 		= Level2.enemies;
				
				sizeX = walls.GetLength(1);
				sizeZ = walls.GetLength(0);
			
				drawLevel();
				break;
			case 3:
				playerX 		= Level3.playerX;
				playerZ 		= Level3.playerZ;
				exitX		 	= Level3.exitX;
				exitZ			= Level3.exitZ;
				exitRotation 	= Level3.exitRotation;
				walls 			= Level3.walls;
				coins 			= Level3.coins;
				enemies 		= Level3.enemies;
				
				sizeX = walls.GetLength(1);
				sizeZ = walls.GetLength(0);
			
				drawLevel();
				break;
			case 4:
				playerX 		= Level4.playerX;
				playerZ 		= Level4.playerZ;
				exitX		 	= Level4.exitX;
				exitZ			= Level4.exitZ;
				exitRotation 	= Level4.exitRotation;
				walls 			= Level4.walls;
				coins 			= Level4.coins;
				enemies 		= Level4.enemies;
				
				sizeX = walls.GetLength(1);
				sizeZ = walls.GetLength(0);
			
				drawLevel();
				break;
			case 5:
				playerX 		= Level5.playerX;
				playerZ 		= Level5.playerZ;
				exitX		 	= Level5.exitX;
				exitZ			= Level5.exitZ;
				exitRotation 	= Level5.exitRotation;
				walls 			= Level5.walls;
				coins 			= Level5.coins;
				enemies 		= Level5.enemies;
				
				sizeX = walls.GetLength(1);
				sizeZ = walls.GetLength(0);
			
				drawLevel();
				break;
			case 6:
				Application.LoadLevel("end");
				break;
		}
		
		
	}
	
	
	void drawLevel() {
		GameObject curLevel = Instantiate(new GameObject("curLevel")) as GameObject;
		
		for (int z = 0; z < sizeZ; z++) {
			for (int x = 0; x < sizeX; x++) {
				Vector3 curPos = new Vector3(1f*x, 0.25f, 1f*z);
				if (walls[z,x] == 1) {
					GameObject wall = Instantiate(wallsPrefab, curPos, new Quaternion()) as GameObject;
					wall.transform.parent = curLevel.transform;	
				}
				if (coins[z,x] == 1) {
					GameObject coin = Instantiate(coinsPrefab, curPos, Quaternion.Euler(0f,0f,90f)) as GameObject;
					coin.layer = 2;
					coin.transform.parent = curLevel.transform;
				}
				if (enemies[z,x] == 1) {
					GameObject enemy = Instantiate(enemyPrefab, curPos, new Quaternion()) as GameObject;
					enemy.layer = 2;
					enemy.transform.parent = curLevel.transform;
				}
			}
		}
		GameObject exit = Instantiate(exitPrefab, new Vector3((float)exitX, -0.24f, (float)exitZ), Quaternion.Euler(0f,exitRotation,0f)) as GameObject;
		exit.layer = 2;
		exit.transform.parent = curLevel.transform;
		GameObject player = Instantiate(playerPrefab, new Vector3((float)playerX, 0f, (float)playerZ), new Quaternion()) as GameObject;
		player.transform.parent = curLevel.transform;
		
		Registry.timerRunning = true;
	}
	
	
	
	public int[,] getWalkables () {
		return walls;	
	}
}
